> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/instance/createzecinstances.md).

# CreateZecInstances

## 1. API Description

This API (CreateZecInstances) is used to create one or more elastic compute instances with specified configurations.

#### Preparations

* Query regular instance types: you can call [DescribeZoneInstanceConfigInfos](/api-reference/zec/instance/describezoneinstanceconfiginfos.md) to query the instance type information.
* Query GPU instance types: you can call [DescribeZoneGpuInstanceConfigInfos](/api-reference/zec/instance/describezonegpuinstanceconfiginfos.md) to query the GPU instance type information.
* Query accelerator instance types: you can call [DescribeZoneAcceleratorConfigInfos](/api-reference/zec/instance/describezoneacceleratorconfiginfos.md) to query the accelerator instance type information.
* Query images: you can call [DescribeImages](/api-reference/zec/image/describeimages.md) to query the image information.
* Query key pairs: you can call [DescribeKeyPairs](/api-reference/security/ccs/key-pair/describekeypairs.md) to query the key pair ID information.

{% hint style="info" %}
**Notes**

* After an instance is created successfully, it starts up automatically and the instance status changes to `RUNNING`. If the creation fails, the status changes to `CREATE_FAILED`.
* Make sure that the account status is normal at the time of purchase.
* Creating instances through this interface supports automatic voucher deduction. For details, see the voucher usage rules.
* This interface is asynchronous. After the request to create instances is submitted successfully, a list of instance `ID`s is returned, but the creation is not completed immediately. During this period, the instance status is `DEPLOYING`. The creation result can be queried by calling the [DescribeInstances](/api-reference/zec/instance/describeinstances.md) interface: if the instance status changes from `DEPLOYING` to `RUNNING`, the creation succeeded; if it changes to `CREATE_FAILED`, the creation failed. No operation can be performed on the instance during the creation.
* Up to **100** instances can be created in a single request.
* The committed traffic package size is valid only when the billing cycle is monthly.
* When the EIP bound through `eipIds` is a CIDR block (Block) EIP, `eipBindType` can only be `Passthrough` and must be specified explicitly (it cannot be omitted, because omitting it is equivalent to `FullNat` and is rejected).
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name          | Required | Type                                                                         | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| zoneId                  | Yes      | String                                                                       | <p>Availability zone ID.</p><p>It can be obtained by calling <a href="/api-reference/zec/location/describezones.md">DescribeZones</a>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| imageId                 | Yes      | String                                                                       | <p>Specify a valid image ID.</p><p>It can be obtained from the imageId field returned by calling <a href="/api-reference/zec/image/describeimages.md">DescribeImages</a>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| instanceType            | Yes      | String                                                                       | <p>Instance type.</p><p>The value for a regular instance can be obtained through <a href="/api-reference/zec/instance/describezoneinstanceconfiginfos.md">DescribeZoneInstanceConfigInfos</a>, and the value for a GPU instance can be obtained through <a href="/api-reference/zec/instance/describezonegpuinstanceconfiginfos.md">DescribeZoneGpuInstanceConfigInfos</a>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| instanceCount           | Yes      | Integer                                                                      | <p>The number of instances to be purchased.</p><p>Value range: \[1,100].</p><p>Default value: 1.</p><p>Value range: \[1, 100]</p><p>Default value: 1</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| subnetId                | Yes      | String                                                                       | <p>Subnet ID.</p><p>It can be obtained by calling <a href="/api-reference/zec/vpc-network/describesubnets.md">DescribeSubnets</a>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| timeZone                | No       | String                                                                       | <p>Time zone of instance.</p><p>Default value: America/Los\_Angeles .</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| instanceName            | No       | String                                                                       | <p>Display name of the instance.</p><p>The length is 2 to 63 characters.</p><p>Only letters, digits, periods (.), underscores (\_), slashes (/), and hyphens (-) are supported.</p><p>It must start and end with a digit or a letter.</p><p>When purchasing multiple instances, you can specify the pattern string \[begin\_number,bits].</p><p>begin\_number: the starting value of the ordinal number. Valid values: \[0,99999]. Default value: 0.</p><p>bits: the number of digits occupied by the ordinal number. Valid values: \[1,6]. Default value: 6.</p><p>Note that the pattern string must not contain spaces.</p><p>When one instance is purchased, for example, server-\[3,3] is displayed as server-003; when two instances are purchased, the instance display names are server-003 and server-004.</p><p>Multiple pattern strings can be specified, such as server-\[3,3]-\[1,1].</p><p>Default value: instance.</p> |
| password                | No       | String                                                                       | <p>Password of the instance.</p><p>Specify either this parameter or keyId (a password and a key cannot be specified for Windows and Generic images).</p><p>It must contain all of the following three types of characters: uppercase and lowercase letters (a-z, A-Z), digits (0-9), and special characters (\~!@$^\*-\_=+).</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| keyId                   | No       | String                                                                       | <p>Key ID.</p><p>Specify either this parameter or password (a password and a key cannot be specified for Windows and Generic images).</p><p>You can call <a href="/api-reference/security/ccs/key-pair/describekeypairs.md">DescribeKeyPairs</a> to obtain the latest key pair information.</p><p>After a key is associated, you can access the instance with the corresponding private key. A key and a password cannot be specified at the same time, and the Windows operating system does not support specifying a key.</p><p>Example value: key-YWD2QFOl.</p>                                                                                                                                                                                                                                                                                                                                                                   |
| nicNetworkType          | No       | [NicNetworkType](/api-reference/zec/datastructure.md#nicnetworktype)         | <p>Network interface mode.</p><p>Default value: Auto .</p><p>Default value: Auto</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| systemDisk              | No       | [SystemDisk](/api-reference/zec/datastructure.md#systemdisk)                 | <p>Boot disk configuration.</p><p>If the value is empty, the boot disk size is the minimum default value to store the operating system.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| dataDisks               | No       | Array of [DataDisk](/api-reference/zec/datastructure.md#datadisk)            | Data disk configuration for the instance. If not specified, no data disk is purchased by default. Each item in the list corresponds to one independent data disk. The total number of data disks is subject to the team quota.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| securityGroupId         | No       | String                                                                       | <p>ID of the security group to be configured on the primary network interface of the instance.</p><p>Only one security group can be associated for now.</p><p>If it is not specified, the security group associated with the VPC is used by default.</p><p>It can be obtained by calling <a href="/api-reference/zec/security-group/describesecuritygroups.md">DescribeSecurityGroups</a>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| lanIp                   | No       | String                                                                       | <p>Starting private IP address to be assigned.</p><p>If this IP is already in use, the addresses after it are assigned in order.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| enableAgent             | No       | Boolean                                                                      | <p>Whether to enable QEMU Guest Agent (QGA). QGA is enabled by default.</p><p>Default value: true</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| enableIpForward         | No       | Boolean                                                                      | <p>Whether to enable IP forwarding. IP forwarding is disabled by default.</p><p>Default value: false</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| internetChargeType      | No       | [InternetChargeType](/api-reference/zec/datastructure.md#internetchargetype) | Public network pricing model.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| trafficPackageSize      | No       | Float                                                                        | <p>Size of the traffic package ordered.</p><p>Unit: TB.</p><p>This value takes effect only when <code>internetChargeType = ByTrafficPackage</code>.</p><p>When <code>ipStackType</code> is <code>IPv4\_IPv6</code>, the traffic package size applies to IPv4.</p><p>Value range: \[0.0, +)</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| bandwidth               | No       | Integer                                                                      | <p>Public outbound bandwidth cap.</p><p>Unit: Mbps .</p><p>Bandwidth cap varies by instance size.</p><p>Value range: \[1, +)</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| eipBindType             | No       | [BindType](/api-reference/zec/datastructure.md#bindtype)                     | <p>Binding mode of the public IP.</p><p>Must be specified when a public IP is assigned.</p><p>When binding a block-type (CIDR) EIP, only <code>Passthrough</code> can be used, and it must be explicitly specified (it cannot be omitted — omitting it is equivalent to <code>FullNat</code> and will be rejected).</p><p>Default value: FullNat</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| eipIds                  | No       | Array of String                                                              | <p>Assign existing EIPs to the instances.</p><p>The number of IPs must be the same as the number of instances to be created.</p><p>If this field is specified, no new EIP is created, and related fields such as <code>networkLineType</code> do not take effect.</p><p>Make sure that the <code>ipStackType</code> of the network interface to be created contains <code>IPv4</code>.</p><p>It can be obtained by calling <a href="/api-reference/zec/elastic-ip/describeeips.md">DescribeEips</a>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                             |
| eipV4Type \[Deprecated] | No       | [EipNetworkType](/api-reference/zec/datastructure.md#eipnetworktype)         | <p>Network type of public IPv4.</p><p>If you need to specify the value, please ensure that your subnet supports IPv4 stack type.</p><p>If the subnet IP stack type is IPv4, the value is required.</p><p>ThreeLine are not supported for now.</p><p>Deprecated. Please use networkLineType instead.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| ipStackType             | No       | [SubnetStackType](/api-reference/zec/datastructure.md#subnetstacktype)       | <p>Set the IP stack type.</p><p>If not specified, IPv4 is used by default when the subnet stack type is IPv4 or IPv4\_IPv6.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| networkLineType         | No       | [NetworkLineType](/api-reference/zec/datastructure.md#networklinetype)       | <p>Network type of public IPv4.</p><p>If you need to specify the value, please ensure that your subnet supports IPv4 stack type.</p><p>If the subnet IP stack type is IPv4, the value is required.</p><p>ThreeLine are not supported for now.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| clusterId               | No       | String                                                                       | <p>Bandwidth cluster ID.</p><p>This parameter is required when the network billing model is <code>BandwidthCluster</code>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| ipv6ClusterId           | No       | String                                                                       | <p>Bandwidth cluster ID of the public IPv6 address.</p><p>Required when the network billing model is <code>BandwidthCluster</code> and <code>ipStackType</code> is IPv4\_IPv6.</p><p>If not specified, <code>clusterId</code> is used by default.</p><p>This field is typically used when IPv4 and IPv6 belong to different bandwidth clusters.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| resourceGroupId         | No       | String                                                                       | <p>Resource group ID where the instances reside.</p><p>If the value is empty, the instance will be added into the default resource group.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| marketingOptions        | No       | [MarketingInfo](/api-reference/zec/datastructure.md#marketinginfo)           | Information on marketing campaigns.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| tags                    | No       | [TagAssociation](/api-reference/zec/datastructure.md#tagassociation)         | <p>Bound tags when creating resources.</p><p>Tag keys must be unique.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| userData                | No       | String                                                                       | <p>Custom initialization script for the instance.</p><p>The value must be Base64-encoded, and the decoded size must be less than 64 KiB.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| instanceOptions         | No       | [InstanceOptions](/api-reference/zec/datastructure.md#instanceoptions)       | Instance options configuration.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |

## 3. Output Parameters

| Parameter Name | Type                                                                              | Description                                                                                                                                                                                                                                                                                                                                                       |
| -------------- | --------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                            | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p>                                                                                                                                                                                                                                             |
| orderNumber    | String                                                                            | Number of order.                                                                                                                                                                                                                                                                                                                                                  |
| instanceIdSet  | Array of String                                                                   | <p>List of instance IDs.</p><p>The returned instance ID list does not mean the creation has been completed.uery the status of the instance according to dataSet . If the status changes from DEPLOYING to RUNNING , it means that the instance has been created successfully; CREATE\_FAILED or no instance found means the instance has been created failed.</p> |
| instances      | Array of [DiskWithInstance](/api-reference/zec/datastructure.md#diskwithinstance) | Set of disk IDs created along with the instances. If no disk is specified, the value is empty.                                                                                                                                                                                                                                                                    |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Create an instance with the simplest parameters. No public IP address is assigned.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateZecInstances
<Common Request Params>

Request：
{
  "zoneId": "asia-east-1a",
  "instanceType": "z2a.cpu.1",
  "imageId": "ubuntu2404_20240712",
  "instanceName": "Test-InstanceName",
  "instanceCount": 1,
  "keyId": "key-rcfljdP5",
  "subnetId": "1272168087751233112",
  "nicNetworkType": "Auto",
  "eipIds": ["<eipId1>"],
  "tags":
    {
      "tags": [
        {
          "key": "key1",
          "value": "value1"
        },
        {
          "key": "key2",
          "value": "value2"
        }
      ]
    }
}

Response:
{
  "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
  "response": {
    "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
    "instanceIdSet": [
      "<instanceId>"
    ],
    "instances": [
    ],
    "orderNumber": "<orderNumber>"
  }
}
```

**2. Create one instance with a public IP. The network line type is BGP, the network is billed by bandwidth cluster, and the bandwidth limit is 10 Mbps.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateZecInstances
<Common Request Params>

Request：
{
  "zoneId": "asia-east-1a",
  "instanceType": "z2a.cpu.1",
  "imageId": "ubuntu2404_20240712",
  "instanceName": "Test-InstanceName",
  "instanceCount": 1,
  "keyId": "key-rcfljdP5",
  "subnetId": "1272168087751233112",
  "internetChargeType": "BandwidthCluster",
  "bandwidth": 10,
  "clusterId": "<clusterId>",
  "networkLineType": "PremiumBGP"
}

Response:
{
  "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
  "response": {
    "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
    "instanceIdSet": [
      "<instanceId>"
    ],
    "instances": [
    ],
    "orderNumber": "<orderNumber>"
  }
}
```

**3. Create one instance with a public IPv4 address and a public IPv6 address. The IPv4 network line type is BGP, the network is billed by bandwidth cluster, and the bandwidth limit is 10 Mbps.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateZecInstances
<Common Request Params>

Request：
{
  "zoneId": "asia-east-1a",
  "instanceType": "z2a.cpu.1",
  "imageId": "ubuntu2404_20240712",
  "instanceName": "Test-InstanceName",
  "instanceCount": 1,
  "keyId": "key-rcfljdP5",
  "subnetId": "1272168087751233112",
  "internetChargeType": "BandwidthCluster",
  "bandwidth": 10,
  "ipStackType": "IPv4_IPv6",
  "clusterId": "<clusterId>",
  "ipv6ClusterId": "<ipv6ClusterId>",
  "networkLineType": "PremiumBGP"
}

Response:
{
  "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
  "response": {
    "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
    "instanceIdSet": [
      "<instanceId>"
    ],
    "instances": [
    ],
    "orderNumber": "<orderNumber>"
  }
}
```

**4. Create one instance with multiple data disks.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateZecInstances
<Common Request Params>

Request：
{
  "zoneId": "asia-east-1a",
  "instanceType": "z2a.cpu.1",
  "imageId": "ubuntu2404_20240712",
  "instanceName": "Test-InstanceName",
  "instanceCount": 1,
  "keyId": "key-rcfljdP5",
  "subnetId": "1272168087751233112",
  "nicNetworkType": "Auto",
  "dataDisks": [
    {
      "diskSize": 100,
      "diskCategory": "Standard NVMe SSD"
    },
    {
      "diskSize": 200,
      "diskCategory": "Standard NVMe SSD"
    }
  ]
}

Response:
{
  "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
  "response": {
    "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
    "instanceIdSet": [
      "<instanceId>"
    ],
    "instances": [
    ],
    "orderNumber": "<orderNumber>"
  }
}
```

**5. Create one instance and specify an initialization script through `userData`. The `userData` in this example is the Base64-encoded value of the script `#!/bin/bash\necho "hello zenlayer" > /tmp/init.log`.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateZecInstances
<Common Request Params>

Request：
{
  "zoneId": "asia-east-1a",
  "instanceType": "z2a.cpu.1",
  "imageId": "ubuntu2404_20240712",
  "instanceName": "Test-InstanceName",
  "instanceCount": 1,
  "keyId": "key-rcfljdP5",
  "subnetId": "1272168087751233112",
  "nicNetworkType": "Auto",
  "userData": "IyEvYmluL2Jhc2gKZWNobyAiaGVsbG8gemVubGF5ZXIiID4gL3RtcC9pbml0LmxvZwo="
}

Response:
{
  "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
  "response": {
    "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
    "instanceIdSet": [
      "<instanceId>"
    ],
    "instances": [
    ],
    "orderNumber": "<orderNumber>"
  }
}
```

**6. Create one instance with a POC voucher. If no POC voucher exists in the system, the creation will fail.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateZecInstances
<Common Request Params>

Request：
{
  "zoneId": "asia-east-1a",
  "instanceType": "z2a.cpu.1",
  "imageId": "ubuntu2404_20240712",
  "instanceName": "Test-InstanceName",
  "instanceCount": 1,
  "keyId": "key-rcfljdP5",
  "subnetId": "1272168087751233112",
  "nicNetworkType": "Auto",
  "marketingOptions": {
    "usePocVoucher": true
  }
}

Response:
{
  "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
  "response": {
    "requestId": "TA471524B-84E1-467B-AB77-75387BBD190B",
    "instanceIdSet": [
      "<instanceId>"
    ],
    "instances": [
    ],
    "orderNumber": "<orderNumber>"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                                            | Description                                                                                                    |
| ---------------- | --------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------- |
| 400              | INVALID\_DISK\_CATEGORY\_TYPE                                         | Disk type error.                                                                                               |
| 400              | INVALID\_EIP\_BINDING\_MODE\_UNSUPPORTED                              | EIP Block does not support NAT binding mode.                                                                   |
| 404              | INVALID\_EIP\_NOT\_FOUND                                              | Elastic IP does not exist.                                                                                     |
| 404              | INVALID\_GPU\_INSTANCE\_TYPE\_NOT\_FOUND                              | GPU instance type does not exist.                                                                              |
| 404              | INVALID\_ACCELERATOR\_TYPE\_NOT\_FOUND                                | Accelerator instance type does not exist.                                                                      |
| 400              | INVALID\_IMAGE\_AGENT\_NOT\_SUPPORT                                   | QGA is not supported for the selected image.                                                                   |
| 400              | INVALID\_IMAGE\_IPV6\_NOT\_SUPPORT                                    | IPv6 stack type is not supported for the selected image.                                                       |
| 400              | INVALID\_IMAGE\_KEY\_PAIR\_NOT\_SUPPORT                               | The image does not support SSH key pairs.                                                                      |
| 404              | INVALID\_IMAGE\_NOT\_FOUND                                            | Image not found.                                                                                               |
| 400              | INVALID\_IMAGE\_PASSWORD\_NOT\_SUPPORT                                | The operating system does not support the specified password.                                                  |
| 400              | INVALID\_IMAGE\_SIZE\_EXCEED                                          | Boot disk size should be larger than the image size.                                                           |
| 400              | INVALID\_IMAGE\_SPEC\_NOT\_SUPPORT                                    | The minimum specification required by the image exceeds the current instance type.                             |
| 400              | INVALID\_INSTANCE\_COUNT\_LIMITATION                                  | You are trying to create more instances than your remaining quota allows.                                      |
| 404              | INVALID\_INSTANCE\_TYPE\_NOT\_FOUND                                   | Instance type not found.                                                                                       |
| 400              | INVALID\_IP\_BROADCAST\_ADDRESS                                       | The IP address cannot be a broadcast address.                                                                  |
| 400              | INVALID\_IP\_FIRST\_ADDRESS                                           | The IP address cannot be a gateway address.                                                                    |
| 400              | INVALID\_IP\_NETWORK\_ADDRESS                                         | The IP address cannot be a network address.                                                                    |
| 400              | INVALID\_IP\_OUT\_OF\_RANGE                                           | Invalid IP address. It does not belong to the CIDR block.                                                      |
| 404              | INVALID\_KEY\_PAIR\_NOT\_FOUND                                        | SSH key pair does not exist.                                                                                   |
| 400              | INVALID\_LOGIN\_SETTING\_CONFLICT                                     | You must and can only pass the value of either password or keyId .                                             |
| 409              | INVALID\_NIC\_INSTANCE\_REGION\_MISMATCH                              | Instance and vNIC are not in the same zone.                                                                    |
| 400              | INVALID\_PARAMETER\_INSTANCE\_NAME\_EXCEED                            | Instance name exceeds the maximum limit.                                                                       |
| 400              | INVALID\_PARAMETER\_INSTANCE\_NAME\_EXCEED\_MINIMUM\_LENGTH           | Instance name should be larger than the minimum limit.                                                         |
| 400              | INVALID\_PARAMETER\_INSTANCE\_NAME\_MALFORMED                         | Invalid instance name format.                                                                                  |
| 400              | INVALID\_PARAMETER\_USER\_DATA\_EXCEED                                | The length of the instance initialization script userData must be less than 64 KiB.                            |
| 404              | INVALID\_PASSWORD\_KEY\_PAIR\_MISSING                                 | Neither password nor SSH key pair is specified.                                                                |
| 400              | INVALID\_PASSWORD\_MALFORMED                                          | Password format error.                                                                                         |
| 404              | INVALID\_REGION\_NOT\_FOUND                                           | The specified region does not exist.                                                                           |
| 400              | INVALID\_REGION\_ZONE\_MISMATCH                                       | The specified availability zone is not under the specified region.                                             |
| 404              | INVALID\_SECURITY\_GROUP\_NOT\_FOUND                                  | The specified security group does not exist.                                                                   |
| 409              | INVALID\_SUBNET\_IPV4\_INSUFFICIENT                                   | Insufficient available IPv4 addresses in the subnet.                                                           |
| 409              | INVALID\_SUBNET\_IPV6\_INSUFFICIENT                                   | Insufficient available IPv6 addresses in the subnet.                                                           |
| 404              | INVALID\_SUBNET\_NOT\_FOUND                                           | Subnet does not exist.                                                                                         |
| 400              | INVALID\_SYSTEM\_DISK\_EXCEED\_LIMIT                                  | Boot disk size exceeds the limit.                                                                              |
| 404              | INVALID\_ZONE\_NOT\_FOUND                                             | Region does not exist.                                                                                         |
| 400              | OPERATION\_DENIED\_CPU\_ILLEGAL                                       | The number of CPUs in the specification is invalid.                                                            |
| 400              | OPERATION\_DENIED\_DISK\_IO\_BURST                                    | The disk bursting function is not enabled.                                                                     |
| 400              | OPERATION\_DENIED\_EIP\_INSTANCE\_NOT\_ADAPTER                        | Specified instance count does not match the number of elastic IPs to be created.                               |
| 400              | OPERATION\_DENIED\_EIP\_INSUFFICIENT                                  | Insufficient elastic IP stock.                                                                                 |
| 400              | OPERATION\_DENIED\_EIP\_IS\_DEFAULT                                   | Default public IP cannot be unbound.                                                                           |
| 400              | OPERATION\_DENIED\_EIP\_IS\_NOT\_UN\_ASSIGN                           | The EIP is already in use (not in the unbound status) and cannot be bound.                                     |
| 400              | OPERATION\_DENIED\_EIP\_NOT\_ASSIGNED                                 | Elastic IP is not bound.                                                                                       |
| 400              | OPERATION\_DENIED\_EIP\_QUOTA\_LIMIT\_EXCEEDED                        | The number of elastic IPs exceeds the quota limit.                                                             |
| 400              | OPERATION\_DENIED\_EIP\_UNSUPPORTED\_NETWORK\_TYPE                    | The EIP network billing method is not supported.                                                               |
| 400              | OPERATION\_DENIED\_MEMORY\_AMOUNT\_ILLEGAL                            | The memory size in the specification is invalid.                                                               |
| 400              | OPERATION\_DENIED\_NIC\_NETWORK\_TYPE\_NOT\_SUPPORT                   | Network interface mode not supported.                                                                          |
| 400              | OPERATION\_DENIED\_STACK\_TYPE\_NOT\_SUPPORT                          | Stack type is not supported.                                                                                   |
| 400              | OPERATION\_DENIED\_SUBNET\_TYPE\_NOT\_SUPPORT                         | Operations on subnets with such IP stack type is not supported.                                                |
| 400              | OPERATION\_DENIED\_SUBNET\_TYPE\_NOT\_SUPPORT\_IPV4                   | Subnet type does not support IPv4.                                                                             |
| 400              | OPERATION\_DENIED\_SUBNET\_ZONE\_MISMATCH                             | Subnet the instance added in is not in the current zone.                                                       |
| 400              | INSTANCE\_STOCK\_INSUFFICIENT                                         | Insufficient instance stock.                                                                                   |
| 400              | UNSUPPORTED\_SUBNET\_TYPE\_FOR\_INTERNET\_CHARGE\_TYPE                | The subnet stack type does not support public network.                                                         |
| 400              | INVALID\_IP\_STACK\_TYPE\_NOT\_SUPPORT                                | IP stack type is not supported.                                                                                |
| 400              | INVALID\_NESTED\_VIRTUALIZATION\_NOT\_ALLOWED                         | Nested virtualization is not allowed.                                                                          |
| 400              | INVALID\_PARAMETER\_FLOW\_PACKAGE\_NOT\_SUPPORTED\_FOR\_PATH\_BASED   | PathBasedBandwidthIP does not support a custom traffic package size. Pass 0 or leave it empty.                 |
| 400              | OPERATION\_DENIED\_FIXED\_BANDWIDTH\_NOT\_SUPPORTED\_FOR\_PATH\_BASED | PathBasedBandwidthIP does not support fixed bandwidth billing.                                                 |
| 400              | OPERATION\_DENIED\_INTERNET\_CHARGE\_TYPE\_NOT\_SUPPORT               | IP network billing type is not supported.                                                                      |
| 400              | OPERATION\_DENIED\_EIP\_NETWORK\_LINE\_TYPE\_NOT\_ON\_SALE            | The IP network line type is not available in this region.                                                      |
| 400              | OPERATION\_DENIED\_EIP\_INTERNET\_CHARGE\_TYPE\_NOT\_AVAILABLE        | The specified IP network line type in this region does not support this network billing mode.                  |
| 409              | INVALID\_INSTANCE\_EIP\_REGION\_MISMATCH                              | The instance and EIP are not on the same region.                                                               |
| 400              | OPERATION\_DENIED\_FLOW\_PACKAGE\_NOT\_SUPPORTED\_HOUR\_PERIOD        | The current product cycle is based on hourly billing and does not support setting a minimum data package size. |
